unit Options;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, Buttons, ExtCtrls, TntStdCtrls, TntExtCtrls,
   TntButtons, TntForms, TntDialogs, TntSysUtils, ShellApi, ProcessViewer;

type
   TfrmOptions = class(TTNTForm)
      pnlAll: TTntPanel;
      gbGeneral: TTntGroupBox;
    cbLock: TTntCheckBox;
      gbVirtualBox: TTntGroupBox;
      gbQemu: TTntGroupBox;
      btnOK: TTntBitBtn;
      btnCancel: TTntBitBtn;
      lblVBExePath: TTntLabel;
      edtVBExePath: TTntEdit;
      btnBrowseForVBExe: TTntSpeedButton;
    cbSecondDrive: TTntCheckBox;
      lblUpdate: TTntLabel;
    cbUseVboxmanage: TTntCheckBox;
    cbDirectly: TTntCheckBox;
      lblQExePath: TTntLabel;
      edtQExePath: TTntEdit;
      btnBrowseForQExe: TTntSpeedButton;
      edtDefaultParameters: TTntEdit;
      lblDefaultParameters: TTntLabel;
      odSearchExe: TTntOpenDialog;
      lblWaitTime: TTntLabel;
      edtWaitTime: TTntEdit;
    cbBackup: TTntCheckBox;
    cbDontWarn: TTntCheckBox;
    cbCPUVirtualizationOption: TTntCheckBox;
      procedure cbUseVboxmanageClick(Sender: TObject);
      procedure cbDirectlyClick(Sender: TObject);
      procedure btnBrowseForVBExeClick(Sender: TObject);
      procedure btnBrowseForQExeClick(Sender: TObject);
      procedure btnOKClick(Sender: TObject);
      procedure edtWaitTimeKeyPress(Sender: TObject; var Key: Char);
      procedure AllKeyDown(Sender: TObject; var Key: Word;
         Shift: TShiftState);
      procedure pmChangeMessageBox(var Msg: TMessage); message WM_USER + 1024;
    procedure edtDefaultParametersChange(Sender: TObject);
   private
      { Private declarations }
   public
      { Public declarations }
   end;

var
   frmOptions: TfrmOptions;

implementation

uses MainForm;

{$R *.dfm}

procedure TfrmOptions.pmChangeMessageBox(var Msg: TMessage);
var
   MBRect: TRect;
   i, x, y, w, h: integer;
   ws: WideString;
   p: PChar;
begin
   GetProcessList;
   i := 0;
   try
      p := MAKEINTRESOURCE(WC_DIALOG);
      ws := WideString('#' + IntToStr(Integer(p)));
   except
      ws := '#32770';
   end;
   while i <= High(ProcessInfo) do
   begin
      if ProcessInfo[i].WClass = ws then
         if ProcessInfo[i].WCaption = msgBoxCaption then
            if GetParent(ProcessInfo[i].Handle) = Handle then
               Break;
      Inc(i);
   end;
   if i <= High(ProcessInfo) then
   begin
      try
         if not GetWindowRect(ProcessInfo[i].Handle, MBRect) then
            Exit;
      except
         Exit;
      end;
      w := MBRect.Right - MBRect.Left;
      h := MBRect.Bottom - MBRect.Top;

      x := Left + ((Width - w) div 2);
      if x < 0 then
         x := 0
      else if x + w > Screen.Width then
         x := Screen.Width - w;

      y := Top + ((Height - h) div 2);
      if y < 0 then
         y := 0
      else if y + h > Screen.Height then
         y := Screen.Height - h;
      try
         SetWindowPos(ProcessInfo[i].Handle, 0, x, y, 0, 0, SWP_NOACTIVATE or SWP_NOSIZE
            or SWP_NOZORDER);
      except
      end;
   end;
end;

procedure TfrmOptions.cbUseVboxmanageClick(Sender: TObject);
begin
   cbDirectly.Checked := not cbUseVboxmanage.Checked;
end;

procedure TfrmOptions.cbDirectlyClick(Sender: TObject);
begin
   cbUseVboxmanage.Checked := not cbDirectly.Checked;
end;

procedure TfrmOptions.btnBrowseForVBExeClick(Sender: TObject);
var
   FolderName: WideString;
begin
   FolderName := WideExtractFilePath(odSearchExe.FileName);
   odSearchExe.FileName := '';
   if FolderName = '' then
   begin
      if odSearchExe.InitialDir = '' then
         odSearchExe.InitialDir := GetEnvVarValue('ProgramFiles');
   end
   else
      odSearchExe.InitialDir := FolderName;
   if odSearchExe.Execute then
   begin
      edtVBExePath.Text := odSearchExe.FileName;
      edtVBExePath.SelStart := Length(edtVBExePath.Text);
      edtVBExePath.SelLength := 0;
   end;
end;

procedure TfrmOptions.btnBrowseForQExeClick(Sender: TObject);
var
   FolderName: WideString;
begin
   FolderName := WideExtractFilePath(odSearchExe.FileName);
   odSearchExe.FileName := '';
   if FolderName = '' then
   begin
      if odSearchExe.InitialDir = '' then
         odSearchExe.InitialDir := GetEnvVarValue('ProgramFiles');
   end
   else
      odSearchExe.InitialDir := FolderName;
   if odSearchExe.Execute then
   begin
      edtQExePath.Text := odSearchExe.FileName;
      edtQExePath.SelStart := Length(edtQExePath.Text);
      edtQExePath.SelLength := 0;
   end;
end;

procedure TfrmOptions.btnOKClick(Sender: TObject);
var
   i: Integer;
begin
   i := StrToIntDef(Trim(edtWaitTime.Text), -1);
   if (i < 0) or (i > 20000) then
   begin
      msgBoxCaption := 'Warning';
      PostMessage(Handle, WM_USER + 1024, 0, 0);
      MessageBoxW(Handle, 'Please set a proper value for the wait time (0..20000) !', 'Warning', MB_OK or MB_ICONWARNING);
      edtWaitTime.SetFocus;
      Exit;
   end;
   if (Trim(edtVBExePath.Text) <> '') and (not WideFileExists(Trim(edtVBExePath.Text))) then
   begin
      msgBoxCaption := 'Warning';
      PostMessage(Handle, WM_USER + 1024, 0, 0);
      MessageBoxW(Handle, PWideChar('The file "' + Trim(edtVBExePath.Text) + '" doesn''t exist !'#13#10'Please clear the VirtualBox Exe Path from the edit box if you don''t want to use it...'), 'Warning', MB_OK or MB_ICONWARNING);
      Exit;
   end;
   if (Trim(edtQExePath.Text) <> '') and (not WideFileExists(Trim(edtQExePath.Text))) then
   begin
      msgBoxCaption := 'Warning';
      PostMessage(Handle, WM_USER + 1024, 0, 0);
      MessageBoxW(Handle, PWideChar('The file "' + Trim(edtQExePath.Text) + '" doesn''t exist !'#13#10'Please clear the Qemu Exe Path from the edit box if you don''t want to use it...'), 'Warning', MB_OK or MB_ICONWARNING);
      Exit;
   end;
   ModalResult := mrOk;
end;

procedure TfrmOptions.edtWaitTimeKeyPress(Sender: TObject; var Key: Char);
begin
   if not (Key in ['0'..'9', #8]) then
      Key := #0;
end;

procedure TfrmOptions.AllKeyDown(Sender: TObject; var Key: Word;
   Shift: TShiftState);
begin
   if (Shift = []) and (Key = VK_F1) then
      frmMain.OpenInternetHelp(Self.Handle, DefSiteHelp);
end;

procedure TfrmOptions.edtDefaultParametersChange(Sender: TObject);
begin
   edtDefaultParameters.ShowHint := Trim(edtDefaultParameters.Text) = WideString('-L . -name "USB Boot Test" -boot c -m 512 -soundhw sb16');
end;

end.

